<?php

namespace App\DataTables;

use App\Models\Dispositivo;
use App\Models\Attivita;
use App\Models\Cucina;
use Illuminate\Database\Eloquent\Builder as QueryBuilder;
use Yajra\DataTables\EloquentDataTable;
use Yajra\DataTables\Html\Builder as HtmlBuilder;
use Yajra\DataTables\Html\Button;
use Yajra\DataTables\Html\Column;
use Yajra\DataTables\Html\Editor\Editor;
use Yajra\DataTables\Html\Editor\Fields;
use Yajra\DataTables\Services\DataTable;
use Illuminate\Support\Facades\Auth;

class PuntoOperatoreDataTable extends DataTable
{
    public function __construct()
    {
        $this->dataTableVariable = 'dataTable_punto_operatore';
    }
    /**
     * Build the DataTable class.
     *
     * @param QueryBuilder<Dispositivo> $query Results from query() method.
     */
    public function dataTable(QueryBuilder $query): EloquentDataTable
    {
        return (new EloquentDataTable($query))
            ->addColumn('action', function($entity){
                return view('punto_operatore.menu', ['entity' => $entity]);
            })
            ->addColumn('is_attivo_display', function($entity){
                return view('_partials.available', ['available' => $entity->is_attivo]);
            })
            ->setRowId('id');
    }

    /**
     * Get the query source of dataTable.
     *
     * @return QueryBuilder<PuntoOperatore>
     */
    public function query(Dispositivo $model): QueryBuilder
    {
        return $model->newQuery()
        ->where('tipo', Dispositivo::OPERATORE)
        ->where('attivita_id', $this->attivita_id);
    }

    /**
     * Optional method if you want to use the html builder.
     */
    public function html(): HtmlBuilder
    {
        $buttons = [];
        if(Auth::user()->can('create-punto_operatore')){
            array_push($buttons, Button::make('create')
                ->editor('editor')
                ->className('btn btn-sm btn-primary mb-4')
                ->formTitle('Crea nuovo punto di operatore')
                ->text('<i class="fas fa-plus"></i> Nuovo punto di operatore'));
        }

        return $this->builder()
                    ->setTableId($this->dataTableVariable)
                    ->columns($this->getColumns())
                    ->minifiedAjax()
                    ->language(asset('assets/Italian.json'))
                    ->dom(count($buttons) == 0 ? 'rtip' : 'Bfrtip')
                    ->responsive(true)
                    ->orderBy(1)
                    ->selectStyleSingle()
                    ->buttons($buttons)
                    ->editor(
                        Editor::make()
                            ->fields([
                                Fields\Text::make('nome')->label('Nome'),
                                Fields\Hidden::make('attivita_id')->label('Attività')->default($this->attivita_id),
                                Fields\Hidden::make('tipo')->label('Tipo')->default(Dispositivo::OPERATORE),
                                Fields\Text::make('licenza')->label('Licenza'),
                                // Fields\Text::make('url_stampante')->label('URL della stampante'),
                                Fields\Select2::make('cucina_id')->label('Cucina')->options(Cucina::where('is_attiva', true)->pluck('id', 'nome')),
                                Fields\Text::make('ubicazione')->label('Ubicazione'),
                                Fields\Text::make('note')->label('Note'),
                                Fields\Boolean::make('is_attivo')->label('Attivo')->default(true),
                                // Fields\Text::make('pin_sblocco')->label('Pin di sblocco'),
                                // Fields\DateTime::make('data_apertura_dispositivo')->label('Data di apertura del dispositivo'),
                                // Fields\DateTime::make('data_chiusura_dispositivo')->label('Data di chiusura del dispositivo'),
                                ])
                    )
                    ->initComplete("function(settings, json){
                        initComplete_punto_operatore();
                    }");
    }

    /**
     * Get the dataTable columns definition.
     */
    public function getColumns(): array
    {
        return [
            Column::make('id')->visible(false),
            Column::make('is_attivo')->data('is_attivo_display')->title('Disponibile'),
            Column::make('nome')->title('Nome'),
            Column::make('attivita_id')->title('Attività'),
            Column::make('tipo')->title('Tipo')->visible(true),
            Column::make('licenza')->title('Licenza'),
            Column::make('url_stampante')->title('URL della stampante'),
            Column::make('ubicazione')->title('Ubicazione'),
            Column::make('pin_sblocco')->title('Pin di sblocco'),
            Column::computed('action')
                  ->title('')
                  ->exportable(false)
                  ->printable(false)
                  ->width(60)
                  ->addClass('text-center'),
        ];
    }

    /**
     * Get the filename for export.
     */
    protected function filename(): string
    {
        return 'PuntoOperatore_' . date('YmdHis');
    }
}
